package main
import (
	"github.com/lxn/walk"
	"AD-Control/public"
)

//---------------------------------------------------------
//
//    Power
//
//---------------------------------------------------------

func menuInitPower(ni * walk.NotifyIcon){
	fa := "电源"
	sub := [...]string{"下班咯","关闭系统","用户注销","重启系统","取消关机计时"}
	
	// 建立空菜单
	nm,err := walk.NewMenu()
	if err != nil {
		public.PrintLog(err)
	}

	for i,buttonText := range sub{
		// 建立 子按钮
		na := walk.NewAction()
		if err := na.SetText(buttonText); err != nil {
			public.PrintLog(err)
		}

		// 为子按钮 添加事件
		switch i{
		case 0:
			na.Triggered().Attach(pWorkOff)
		case 1:
			na.Triggered().Attach(pCloseWindows)
		case 2:
			na.Triggered().Attach(pLogOffUser)
		case 3:
			na.Triggered().Attach(pRebootWindows)
		case 4:
			na.Triggered().Attach(pCancelCloseWindows)
		
		}

		// 将 子按钮 添加到 菜单
		nm.Actions().Add(na)
	}
	//将菜单添加到托盘
	sysmenu,err := ni.ContextMenu().Actions().AddMenu(nm)
	if err != nil {
		public.PrintLog(err)
	}

	// 主菜单 属性
	sysmenu.SetText(fa)
	sysmenu.SetVisible(true)
	sysmenu.SetEnabled(true)
}
func pWorkOff(){
	public.SendServerReport(public.Msg_Report_Offwork)
}
func pCloseWindows(){
	public.SendServerExec(public.Msg_Exec_CloseWindows)
}
func pLogOffUser(){
	public.SendServerExec(public.Msg_Exec_LogOffUser)

}
func pRebootWindows(){
	public.SendServerExec(public.Msg_Exec_RebootWindows)

}
func pCancelCloseWindows(){
	public.SendServerExec(public.Msg_Exec_CancelCloseWindows)
}

//--------------------------------------------------------------------
//
//    Software Install
//
//--------------------------------------------------------------------
func menuInitSoftwareInstall(ni * walk.NotifyIcon){
	fa := "软件安装"
	// 建立空菜单
	nm,err := walk.NewMenu()
	if err != nil {
		public.PrintLog(err)
	}
	list,err := public.ReadDir(public.Env_ADSoftlike)
	if err != nil {
		public.PrintLog(err)
	}
	for _,ueach := range list{
		each := ueach.Name()
		if each == ".DS_Store"{
			continue
		}
		each_noext := public.TrimSuffix(public.TrimSuffix(ueach.Name(),".exe"),".msi")

		// 建立 子按钮
		na := walk.NewAction()
		if err := na.SetText(each_noext); err != nil {
			public.PrintLog(err)
		}

		// 为子按钮 添加事件
		na.Triggered().Attach(func() {
			siEnter_admin(each)
		})

		// 将 子按钮 添加到 菜单
		nm.Actions().Add(na)
	}
	//将菜单添加到托盘
	sysmenu,err := ni.ContextMenu().Actions().AddMenu(nm)
	if err != nil {
		public.PrintLog(err)
	}

	// 主菜单 属性
	sysmenu.SetText(fa)
	sysmenu.SetVisible(true)
	sysmenu.SetEnabled(true)
}
func siEnter_admin(softname string){
	go public.Msg("等待弹出安装窗口，请稍等。。")
	ifFile := public.Exist(`C:\windows\`+softname)
	public.SendServer(public.GJexecInstallSoftware(ifFile,softname))

}

//---------------------------------------------------------------
//
//     WxDrive Sync
//
//---------------------------------------------------------------
func menuInitWxDriveSync(ni * walk.NotifyIcon){
	fa := "微盘同步"
	sub := [...]string{"初始化","开启服务器同步到微盘","开启微盘同步到服务器","说明"}
	// 建立空菜单
	nm,err := walk.NewMenu()
	if err != nil {
		public.PrintLog(err)
	}

	for i,buttonText := range sub{
		// 建立 子按钮
		na := walk.NewAction()
		if err := na.SetText(buttonText); err != nil {
			public.PrintLog(err)
		}

		// 为子按钮 添加事件
		switch i{
		case 0:
			na.Triggered().Attach(wxdsInit)
		case 1:
			na.Triggered().Attach(wxdsToDrive)
		case 2:
			na.Triggered().Attach(wxdsToServer)
		case 3:
			na.Triggered().Attach(wxdsExplain)
		
		}

		// 将 子按钮 添加到 菜单
		nm.Actions().Add(na)
	}

	//将菜单添加到托盘
	sysmenu,err := ni.ContextMenu().Actions().AddMenu(nm)
	if err != nil {
		public.PrintLog(err)
	}

	// 主菜单 属性
	sysmenu.SetText(fa)
	sysmenu.SetVisible(true)
	sysmenu.SetEnabled(true)
}
func wxdsInit(){
	public.Msg("开发ing")
}
func wxdsToDrive(){
	public.Msg("开发ing")

}
func wxdsToServer(){
	public.Msg("开发ing")

} 
func wxdsExplain(){
	public.Msg("开发ing")

}
//---------------------------------------------------------------
//
//     User Tools
//
//---------------------------------------------------------------
func menuInitUserTools(ni * walk.NotifyIcon){
	fa := "用户工具"
	sub := [...]string{"隐藏桌面图标","恢复桌面图标"}
	// 建立空菜单
	nm,err := walk.NewMenu()
	if err != nil {
		public.PrintLog(err)
	}

	for i,buttonText := range sub{
		// 建立 子按钮
		na := walk.NewAction()
		if err := na.SetText(buttonText); err != nil {
			public.PrintLog(err)
		}

		// 为子按钮 添加事件
		switch i{
		case 0:
			na.Triggered().Attach(utHideIcon)
		case 1:
			na.Triggered().Attach(utShowIcon)
		
		}

		// 将 子按钮 添加到 菜单
		nm.Actions().Add(na)
	}

	//将菜单添加到托盘
	sysmenu,err := ni.ContextMenu().Actions().AddMenu(nm)
	if err != nil {
		public.PrintLog(err)
	}

	// 主菜单 属性
	sysmenu.SetText(fa)
	sysmenu.SetVisible(true)
	sysmenu.SetEnabled(true)
}

func utHideIcon(){
	public.Msg("emmmmmmm,大概下周吧，这周无望哈")
}
func utShowIcon(){
	public.Msg("仅供参考！！")
}


//---------------------------------------------------------------
//
//     file share
//
//---------------------------------------------------------------

func menuInitFileShares(ni * walk.NotifyIcon){
	// envhs := os.Getenv("HOMESHARE")
	// public.PrintLog(envhs)

	fa := "文件共享"

	// // 建立空菜单
	mfs,err := walk.NewMenu()
	if err != nil {
		public.PrintLog(err)
	}

	deptList,err := public.ReadDir(public.Env_ADMain)
	if err !=nil {
		public.PrintLog(err)
	}
	for _,memberList := range deptList {
		nm,err := walk.NewMenu()
		if err != nil {
			public.PrintLog(err)
		}
		deptshare := memberList.Name()

		member,err := public.ReadDir(public.Env_ADMain + `\` + deptshare)
		if err != nil {
			public.PrintLog(err)
		}
		for _,mem := range member{
			wokrer := mem.Name()
			// 建立 子按钮
			na := walk.NewAction()
			if err := na.SetText(public.TrimSuffix(wokrer,".lnk")); err != nil {
				public.PrintLog(err)
			}

			// 为子按钮 添加事件
			na.Triggered().Attach(func(){fsOpenWindow(public.Env_ADMain + `\` + deptshare + `\` + wokrer);return})
				
			// 将 子按钮 添加到 菜单 
			nm.Actions().Add(na)
	
		}
		
		if m,err := mfs.Actions().AddMenu(nm);err != nil{
			public.PrintLog(err)
		}else{
			m.SetText(deptshare)
			m.SetVisible(true)
			m.SetEnabled(true)

		}
	}

	//将菜单添加到托盘
	sysmenu,err := ni.ContextMenu().Actions().AddMenu(mfs)
	if err != nil {
		public.PrintLog(err)
	}

	// 主菜单 属性
	sysmenu.SetText(fa)
	sysmenu.SetVisible(true)
	sysmenu.SetEnabled(true)
}
func fsOpenWindow(s string){
	public.PrintLog(s)
	public.Execcmd_nowait("explorer "+s)
}


//---------------------------------------------------------------
//
//     Other
//
//---------------------------------------------------------------

func menuInitOther(ni * walk.NotifyIcon){
	fa := "其他"

	sub := [...]string{"Excel关键词分割","移动硬盘","重新加载","测试"}
	// 建立空菜单
	nm,err := walk.NewMenu()
	if err != nil {
		public.PrintLog(err)
	}
	lastone := len(sub)-1
	for i,buttonText := range sub{
		
		switch i{
		case 1:
			if ! public.TheUser(public.AD_User_huyibo) {continue}
		case lastone:
			if ! public.AdminUser() {continue}
		}
		// 建立 子按钮
		na := walk.NewAction()
		if err := na.SetText(buttonText); err != nil {
			public.PrintLog(err)
		}

		// 为子按钮 添加事件
		switch i{
		case 0:
			na.Triggered().Attach(oMultiSplit)
		case 1:
			
			na.Triggered().Attach(oJR_huyibo_movedisk)
		case lastone:
			na.Triggered().Attach(oTest)
		
		}

		// 将 子按钮 添加到 菜单
		nm.Actions().Add(na)
	}

	//将菜单添加到托盘
	sysmenu,err := ni.ContextMenu().Actions().AddMenu(nm)
	if err != nil {
		public.PrintLog(err)
	}

	// 主菜单 属性
	sysmenu.SetText(fa)
	sysmenu.SetVisible(true)
	sysmenu.SetEnabled(true)
	
}
func oMultiSplit(){
	public.Execcmd_nowait(public.Startk + public.Link_MultiSplit)
}
func oJR_huyibo_movedisk(){
	public.SendDaemonExec(`F:\SamsungPortableSSD.exe`)
}
func oRebootUser(){
	//public.Execcmd_nowait(public.Env_ADSoftTool_RebootUser)
}


func oTest(){
	public.SendDaemonExec(`D:\WXWork.exe`)
}
